#version 140

uniform sampler2DArray hfPyramid;
uniform float size;
uniform float level;

in vec2 ex_TexCoord;
out vec4 Fragment_Color;

vec4 texture2DBilinear(in sampler2DArray textureSampler,in vec3 uv)
{
	float res = 1.0/size;
	//float res = 0.5/size;
	vec4 c;

	c = texture(textureSampler, uv) * 0.25;
   	c += texture(textureSampler, uv + vec3(res, 0.0, 0.0)) * 0.25;
   	c += texture(textureSampler, uv + vec3(0.0, res, 0.0)) * 0.25;
    c += texture(textureSampler, uv + vec3(res, res, 0.0)) * 0.25;

	return c;
}

void main()
{
	vec3 tex_coord = vec3(ex_TexCoord, level);
	Fragment_Color = texture2DBilinear(hfPyramid, tex_coord.xyz);
}
