#version 140

uniform sampler2D keyLightSampler;
uniform sampler2D envLightSampler;

in vec2 ex_TexCoord;
out vec4 Fragment_Color;

void main()
{
	vec4 env_Color = texture2D(envLightSampler, ex_TexCoord);
	vec4 key_Color = texture2D(keyLightSampler, ex_TexCoord);
	
	vec4 result = env_Color + key_Color;
	result = clamp(result, 0.0, 1.0);
	
	Fragment_Color = mix(env_Color, result, 0.99);
	//Fragment_Color = env_Color + key_Color;
	//Fragment_Color = key_Color;//vec4(ex_TexCoord.x,ex_TexCoord.y,0.0,1.0);
}
