#version 140

uniform mat4 ModelViewMatrix;
uniform mat4 ProjectionMatrix;

uniform vec3 LightSourcePosition;
uniform vec3 LightSourceHalfVector;

in vec3 Position;
in vec2 TexCoord;
in vec3 Normal;
in vec4 Tangent;


out vec2 ex_TexCoord;
out vec3 LightDirection;
out vec3 LightHalfVector;

void main()
{
	ex_TexCoord = TexCoord;
	vec3 tmpPos = Position;
	tmpPos *= 3.0;
  
	vec3 n = normalize(ModelViewMatrix * vec4(Normal,0.0)).xyz;
	vec3 t = normalize(ModelViewMatrix * vec4(Tangent.xyz,0.0)).xyz;
	vec3 b = cross(n, t) * Tangent.w;
  
	mat3 tbnMatrix = mat3(t.x, b.x, n.x,
		                  t.y, b.y, n.y,
			              t.z, b.z, n.z);
                        
	LightDirection = tbnMatrix * LightSourcePosition;
	LightHalfVector = tbnMatrix * LightSourceHalfVector;
  
	gl_Position = ProjectionMatrix * ModelViewMatrix * vec4(tmpPos, 1.0);
}