#version 140

uniform sampler2D tex_Source;
//uniform sampler2D normalMap;

uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;

uniform vec3 lightPos;
in vec3 Position;

out vec2 ex_TexCoord;

out vec3 ex_v;
out vec3 light_v;

void main()
{
	ex_TexCoord = vec2(0.5)*Position.xz + vec2(0.5);
	//ex_Normal = texture2D(tex_Source, ex_TexCoord).z;
	ex_v = (viewMatrix * vec4(Position, 1.0)).xyz;
	light_v = normalize(lightPos - ex_v);
	
  vec3 tmpPos = vec3(Position.xyz);
  tmpPos.xz *= vec2(3.0);
	tmpPos.y = texture2D(tex_Source, ex_TexCoord).z;
	gl_Position = projectionMatrix * viewMatrix *  vec4(tmpPos, 1.0);
}