#version 140

uniform sampler2DArray tex_Source;
uniform float level;

in vec2 ex_TexCoord;
out vec4 ex_Color;

vec4 filter(in vec3 texCoord, in float res)
{
	float c = 1.0 / res;

	//vec2 xPow1 = fract(texCoord.xy*res - 0.5);
	vec2 xPow1 = fract(texCoord.xy*res - 0.5);
	vec2 xPow2 = xPow1 * xPow1;
	vec2 xPow3 = xPow2 * xPow1;
	
	vec2 filterWeight0 = 0.5 * xPow3 - xPow2 + (4.0/6.0);
	vec2 filterWeight1 = (1.0/6.0) * xPow3;
	
	// g(x)
	vec2 g0 = (2.0/6.0) * xPow3 - (0.5 * xPow2) - 0.5 * xPow1 + (5.0/6.0);
	vec2 g1 = 1.0 - g0;
	
	// h(x)
	vec2 h0 = (1.0 - filterWeight0 / g0 + xPow1) * c;
	vec2 h1 = (1.0 + filterWeight1 / g1 - xPow1) * c;

	vec2 coord_source = texCoord.xy;

	vec2 coord_source10 = coord_source + vec2(h1.x, 0);
	vec2 coord_source00 = coord_source - vec2(h0.x, 0);
	
	vec2 coord_source11 = coord_source10 + vec2(0, h1.y);
	vec2 coord_source01 = coord_source00 + vec2(0, h1.y);
	
	coord_source10 = coord_source10 - vec2(0, h0.y);
	coord_source00 = coord_source00 - vec2(0, h0.y);
	
	//fetch four linearly interpolated inputs
	vec4 tex_source00 = texture(tex_Source, vec3(coord_source00, level));
	vec4 tex_source10 = texture(tex_Source, vec3(coord_source10, level));
	vec4 tex_source01 = texture(tex_Source, vec3(coord_source01, level));
	vec4 tex_source11 = texture(tex_Source, vec3(coord_source11, level));
	
	//weight along y direction 
	tex_source00 = mix(tex_source00, tex_source01, g1.y);
	tex_source10 = mix(tex_source10, tex_source11, g1.y);
	
	// weight along x direction
	return mix(tex_source00, tex_source10, g1.x);
}

void main()
{
	//vec4 tex_coord = vec4(ex_TexCoord.x, ex_TexCoord.y, level, 1.0);
	//ex_Color = vec4(1.0,0.0,0.0,1.0);
	ex_Color = filter(vec3(ex_TexCoord,1.0), 256.0);
}
